std::ctype(3)

NAME
std::ctype -

SYNOPSIS

Inherits __ctype_abstract_base< _CharT >.

Inherited by ctype_byname.

Detailed Description

  template<typename _CharT> class std::ctype< _CharT >
This template class defines classification and conversion functions for character sets. It wraps <cctype> functionality. Ctype gets used by streams for many I/O operations.

This template provides the protected virtual functions the developer will have to replace in a derived class or specialization to make a working facet. The public functions that access them are defined in __ctype_abstract_base, to allow for implementation flexibility. See ctype<wchar_t> for an example. The functions are documented in __ctype_abstract_base.

Note: implementations are provided for all the protected virtual functions, but will likely not be useful.

Definition at line 606 of file locale_facets.h.

  Public Types
typedef const int * __to_type
typedef _CharT char_type
typedef __ctype_abstract_base< _CharT >::mask mask

  Public Member Functions
ctype (size_t __refs=0)
const char_type * is (const char_type *__lo, const char_type *__hi, mask *__vec) const
bool is (mask __m, char_type __c) const
const char_type * narrow (const char_type *__lo, const char_type *__hi, char __dfault, char *__to) const
char narrow (char_type __c, char __dfault) const
const char_type * scan_is (mask __m, const char_type *__lo, const char_type *__hi) const
const char_type * scan_not (mask __m, const char_type *__lo, const char_type *__hi) const
const char_type * tolower (char_type *__lo, const char_type *__hi) const
char_type tolower (char_type __c) const
const char_type * toupper (char_type *__lo, const char_type *__hi) const
char_type toupper (char_type __c) const
const char * widen (const char *__lo, const char *__hi, char_type *__to) const
char_type widen (char __c) const

  Static Public Attributes
static const mask alnum
static const mask alpha
static const mask cntrl
static const mask digit
static const mask graph
static locale::id id
static const mask lower
static const mask print
static const mask punct
static const mask space
static const mask upper
static const mask xdigit

  Protected Member Functions
virtual const char_type * do_is (const char_type *__lo, const char_type *__hi, mask *__vec) const =0
virtual bool do_is (mask __m, char_type __c) const =0
virtual const char_type * do_is (const char_type *__lo, const char_type *__hi, mask *__vec) const
virtual bool do_is (mask __m, char_type __c) const
virtual const char_type * do_narrow (const char_type *__lo, const char_type *__hi, char __dfault, char *__dest) const
virtual char do_narrow (char_type, char __dfault) const
virtual const char_type * do_scan_is (mask __m, const char_type *__lo, const char_type *__hi) const =0
virtual const char_type * do_scan_is (mask __m, const char_type *__lo, const char_type *__hi) const
virtual const char_type * do_scan_not (mask __m, const char_type *__lo, const char_type *__hi) const =0
virtual const char_type * do_scan_not (mask __m, const char_type *__lo, const char_type *__hi) const
virtual const char_type * do_tolower (char_type *__lo, const char_type *__hi) const
virtual char_type do_tolower (char_type __c) const
virtual const char_type * do_toupper (char_type *__lo, const char_type *__hi) const
virtual char_type do_toupper (char_type __c) const
virtual const char * do_widen (const char *__lo, const char *__hi, char_type *__dest) const
virtual char_type do_widen (char __c) const

  Static Protected Member Functions
static __c_locale _S_clone_c_locale (__c_locale &__cloc)
static void _S_create_c_locale (__c_locale &__cloc, const char *__s, __c_locale __old=0)
static void _S_destroy_c_locale (__c_locale &__cloc)
static __c_locale _S_get_c_locale ()
static const char * _S_get_c_name ()

  Friends
class locale::_Impl

Member Typedef Documentation

  typedef _CharT char_type

Typedef for the template parameter.

Reimplemented from __ctype_abstract_base.

Reimplemented in ctype_byname.

Definition at line 610 of file locale_facets.h.

Member Function Documentation

  virtual const char_type* do_is (const char_type * __lo, const char_type * __hi, mask * __vec) const [protected, pure virtual, inherited]

Return a mask array.

This function finds the mask for each char_type in the range [lo,hi) and successively writes it to vec. vec must have as many elements as the input.

do_is() is a hook for a derived facet to change the behavior of classifying. do_is() must always return the same result for the same input.

Parameters:
    lo Pointer to start of range.
    hi Pointer to end of range.
    vec Pointer to an array of mask storage.

Returns:
    hi.

  virtual bool do_is (mask __m, char_type __c) const [protected, pure virtual, inherited]

Test char_type classification.

This function finds a mask M for c and compares it to mask m.

do_is() is a hook for a derived facet to change the behavior of classifying. do_is() must always return the same result for the same input.

Parameters:
    c The char_type to find the mask of.
    m The mask to compare against.

Returns:
    (M & m) != 0.

Referenced by __ctype_abstract_base< wchar_t >::is().

  virtual const char_type* do_narrow (const char_type * __lo, const char_type * __hi, char __dfault, char * __dest) const [protected, virtual]

Narrow char_type array to char.

This virtual function converts each char_type in the range [lo,hi) to char using the simplest reasonable transformation and writes the results to the destination array. For any element in the input that cannot be converted, dfault is used instead.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:
    lo Pointer to start of range.
    hi Pointer to end of range.
    dfault Char to use if conversion fails.
    to Pointer to the destination array.

Returns:
    hi.

Implements __ctype_abstract_base.

  virtual char do_narrow (char_type, char __dfault) const [protected, virtual]

Narrow char_type to char.

This virtual function converts the argument to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:
    c The char_type to convert.
    dfault Char to return if conversion fails.

Returns:
    The converted char.

Implements __ctype_abstract_base.

Referenced by ctype< char >::narrow().

  virtual const char_type* do_scan_is (mask __m, const char_type * __lo, const char_type * __hi) const [protected, pure virtual, inherited]

Find char_type matching mask.

This function searches for and returns the first char_type c in [lo,hi) for which is(m,c) is true.

do_scan_is() is a hook for a derived facet to change the behavior of match searching. do_is() must always return the same result for the same input.

Parameters:
    m The mask to compare against.
    lo Pointer to start of range.
    hi Pointer to end of range.

Returns:
    Pointer to a matching char_type if found, else hi.

Referenced by __ctype_abstract_base< wchar_t >::scan_is().

  virtual const char_type* do_scan_not (mask __m, const char_type * __lo, const char_type * __hi) const [protected, pure virtual, inherited]

Find char_type not matching mask.

This function searches for and returns a pointer to the first char_type c of [lo,hi) for which is(m,c) is false.

do_scan_is() is a hook for a derived facet to change the behavior of match searching. do_is() must always return the same result for the same input.

Parameters:
    m The mask to compare against.
    lo Pointer to start of range.
    hi Pointer to end of range.

Returns:
    Pointer to a non-matching char_type if found, else hi.

Referenced by __ctype_abstract_base< wchar_t >::scan_not().

  virtual const char_type* do_tolower (char_type * __lo, const char_type * __hi) const [protected, virtual]

Convert array to lowercase.

This virtual function converts each char_type in the range [lo,hi) to lowercase if possible. Other elements remain untouched.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters:
    lo Pointer to start of range.
    hi Pointer to end of range.

Returns:
    hi.

Implements __ctype_abstract_base.

  virtual char_type do_tolower (char_type __c) const [protected, virtual]

Convert to lowercase.

This virtual function converts the argument to lowercase if possible. If not possible (for example, '2'), returns the argument.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters:
    c The char_type to convert.

Returns:
    The lowercase char_type if convertible, else c.

Implements __ctype_abstract_base.

Referenced by ctype< char >::tolower().

  virtual const char_type* do_toupper (char_type * __lo, const char_type * __hi) const [protected, virtual]

Convert array to uppercase.

This virtual function converts each char_type in the range [lo,hi) to uppercase if possible. Other elements remain untouched.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters:
    lo Pointer to start of range.
    hi Pointer to end of range.

Returns:
    hi.

Implements __ctype_abstract_base.

  virtual char_type do_toupper (char_type __c) const [protected, virtual]

Convert to uppercase.

This virtual function converts the char_type argument to uppercase if possible. If not possible (for example, '2'), returns the argument.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters:
    c The char_type to convert.

Returns:
    The uppercase char_type if convertible, else c.

Implements __ctype_abstract_base.

Referenced by ctype< char >::toupper().

  virtual const char* do_widen (const char * __lo, const char * __hi, char_type * __dest) const [protected, virtual]

Widen char array.

This function converts each char in the input to char_type using the simplest reasonable transformation.

do_widen() is a hook for a derived facet to change the behavior of widening. do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:
    lo Pointer to start range.
    hi Pointer to end of range.
    to Pointer to the destination array.

Returns:
    hi.

Implements __ctype_abstract_base.

  virtual char_type do_widen (char __c) const [protected, virtual]

Widen char.

This virtual function converts the char to char_type using the simplest reasonable transformation.

do_widen() is a hook for a derived facet to change the behavior of widening. do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:
    c The char to convert.

Returns:
    The converted char_type

Implements __ctype_abstract_base.

Referenced by ctype< char >::widen().

  const char_type* is (const char_type * __lo, const char_type * __hi, mask * __vec) const [inline, inherited]

Return a mask array.

This function finds the mask for each char_type in the range [lo,hi) and successively writes it to vec. vec must have as many elements as the char array. It does so by returning the value of ctype<char_type>::do_is().

Parameters:
    lo Pointer to start of range.
    hi Pointer to end of range.
    vec Pointer to an array of mask storage.

Returns:
    hi.

Definition at line 180 of file locale_facets.h.

  bool is (mask __m, char_type __c) const [inline, inherited]

Test char_type classification.

This function finds a mask M for c and compares it to mask m. It does so by returning the value of ctype<char_type>::do_is().

Parameters:
    c The char_type to compare the mask of.
    m The mask to compare against.

Returns:
    (M & m) != 0.

Definition at line 163 of file locale_facets.h.

Referenced by money_get::_M_extract(), and basic_istream::sentry::sentry().

  const char_type* narrow (const char_type * __lo, const char_type * __hi, char __dfault, char * __to) const [inline, inherited]

Narrow array to char array.

This function converts each char_type in the input to char using the simplest reasonable transformation and writes the results to the destination array. For any char_type in the input that cannot be converted, dfault is used instead. It does so by returning ctype<char_type>::do_narrow(lo, hi, dfault, to).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:
    lo Pointer to start of range.
    hi Pointer to end of range.
    dfault Char to use if conversion fails.
    to Pointer to the destination array.

Returns:
    hi.

Definition at line 347 of file locale_facets.h.

  char narrow (char_type __c, char __dfault) const [inline, inherited]

Narrow char_type to char.

This function converts the char_type to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead. It does so by returning ctype<char_type>::do_narrow(c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:
    c The char_type to convert.
    dfault Char to return if conversion fails.

Returns:
    The converted char.

Definition at line 325 of file locale_facets.h.

Referenced by time_get::_M_extract_num(), time_get::do_get_year(), and time_put::put().

  const char_type* scan_is (mask __m, const char_type * __lo, const char_type * __hi) const [inline, inherited]

Find char_type matching a mask.

This function searches for and returns the first char_type c in [lo,hi) for which is(m,c) is true. It does so by returning ctype<char_type>::do_scan_is().

Parameters:
    m The mask to compare against.
    lo Pointer to start of range.
    hi Pointer to end of range.

Returns:
    Pointer to matching char_type if found, else hi.

Definition at line 196 of file locale_facets.h.

  const char_type* scan_not (mask __m, const char_type * __lo, const char_type * __hi) const [inline, inherited]

Find char_type not matching a mask.

This function searches for and returns the first char_type c in [lo,hi) for which is(m,c) is false. It does so by returning ctype<char_type>::do_scan_not().

Parameters:
    m The mask to compare against.
    lo Pointer to first char in range.
    hi Pointer to end of range.

Returns:
    Pointer to non-matching char if found, else hi.

Definition at line 212 of file locale_facets.h.

Referenced by money_put::_M_insert().

  const char_type* tolower (char_type * __lo, const char_type * __hi) const [inline, inherited]

Convert array to lowercase.

This function converts each char_type in the range [lo,hi) to lowercase if possible. Other elements remain untouched. It does so by returning ctype<char_type>:: do_tolower(lo, hi).

Parameters:
    lo Pointer to start of range.
    hi Pointer to end of range.

Returns:
    hi.

Definition at line 270 of file locale_facets.h.

  char_type tolower (char_type __c) const [inline, inherited]

Convert to lowercase.

This function converts the argument to lowercase if possible. If not possible (for example, '2'), returns the argument. It does so by returning ctype<char_type>::do_tolower(c).

Parameters:
    c The char_type to convert.

Returns:
    The lowercase char_type if convertible, else c.

Definition at line 255 of file locale_facets.h.

  const char_type* toupper (char_type * __lo, const char_type * __hi) const [inline, inherited]

Convert array to uppercase.

This function converts each char_type in the range [lo,hi) to uppercase if possible. Other elements remain untouched. It does so by returning ctype<char_type>:: do_toupper(lo, hi).

Parameters:
    lo Pointer to start of range.
    hi Pointer to end of range.

Returns:
    hi.

Definition at line 241 of file locale_facets.h.

  char_type toupper (char_type __c) const [inline, inherited]

Convert to uppercase.

This function converts the argument to uppercase if possible. If not possible (for example, '2'), returns the argument. It does so by returning ctype<char_type>::do_toupper().

Parameters:
    c The char_type to convert.

Returns:
    The uppercase char_type if convertible, else c.

Definition at line 226 of file locale_facets.h.

Referenced by time_get::_M_extract_name().

  const char* widen (const char * __lo, const char * __hi, char_type * __to) const [inline, inherited]

Widen array to char_type.

This function converts each char in the input to char_type using the simplest reasonable transformation. It does so by returning ctype<char_type>::do_widen(c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:
    lo Pointer to start of range.
    hi Pointer to end of range.
    to Pointer to the destination array.

Returns:
    hi.

Definition at line 306 of file locale_facets.h.

  char_type widen (char __c) const [inline, inherited]

Widen char to char_type.

This function converts the char argument to char_type using the simplest reasonable transformation. It does so by returning ctype<char_type>::do_widen(c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:
    c The char to convert.

Returns:
    The converted char_type.

Definition at line 287 of file locale_facets.h.

Referenced by __moneypunct_cache::_M_cache(), __numpunct_cache::_M_cache(), num_put::_M_insert_float(), __pad::_S_pad(), money_get::do_get(), time_put::do_put(), and money_put::do_put().

Member Data Documentation

  locale::id id [static]

The facet id for ctype<char_type>.

Definition at line 614 of file locale_facets.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.